import * as _nextui_org_system from '@nextui-org/system';
import { HTMLNextUIProps, PropGetter } from '@nextui-org/system';
import * as tailwind_variants from 'tailwind-variants';
import * as react from 'react';
import { SpinnerVariantProps, SlotsToClasses, SpinnerSlots } from '@nextui-org/theme';
import { ReactRef } from '@nextui-org/shared-utils';

interface UseSpinnerProps extends HTMLNextUIProps<"div", SpinnerVariantProps> {
    /**
     * Ref to the DOM node.
     */
    ref?: ReactRef<HTMLDivElement | null>;
    /**
     * Spinner label, in case you passed it will be used as `aria-label`.
     */
    label?: string;
    /**
     * Classname or List of classes to change the styles of the element.
     * if `className` is passed, it will be added to the base slot.
     *
     * @example
     * ```ts
     * <Spinner styles={{
     *    base:"base-classes",
     *    line1: "circle1-classes",
     *    line2: "circle2-classes",
     *    label: "label-classes"
     * }} />
     * ```
     */
    styles?: SlotsToClasses<SpinnerSlots>;
}
declare function useSpinner(originalProps: UseSpinnerProps): {
    domRef: react.RefObject<HTMLDivElement>;
    label: react.ReactNode;
    slots: {
        base: (slotProps?: tailwind_variants.ClassProp<tailwind_variants.ClassValue> | undefined) => string;
        label: (slotProps?: tailwind_variants.ClassProp<tailwind_variants.ClassValue> | undefined) => string;
        circle1: (slotProps?: tailwind_variants.ClassProp<tailwind_variants.ClassValue> | undefined) => string;
        circle2: (slotProps?: tailwind_variants.ClassProp<tailwind_variants.ClassValue> | undefined) => string;
    };
    styles: SlotsToClasses<"base" | "label" | "circle1" | "circle2"> | undefined;
    getSpinnerProps: PropGetter<Record<string, unknown>, _nextui_org_system.DOMAttributes<_nextui_org_system.DOMElement>>;
};
type UseSpinnerReturn = ReturnType<typeof useSpinner>;

export { UseSpinnerProps, UseSpinnerReturn, useSpinner };
